"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
class Count extends stream_1.PassThrough {
    constructor(handler) {
        super({ objectMode: true });
        this.accumulator = 0;
        this.handler = handler;
        this.on('data', (data) => {
            if (this.handler(data)) {
                this.accumulator++;
            }
        });
    }
    result() {
        return this.accumulator;
    }
}
exports.Count = Count;
//# sourceMappingURL=count.js.map