"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
class List extends stream_1.PassThrough {
    constructor(handler) {
        super({ objectMode: true });
        this.accumulator = [];
        this.handler = handler;
        this.on('data', (data) => {
            const result = this.handler(data);
            if (result) {
                this.accumulator.push(result);
            }
        });
    }
    result() {
        return this.accumulator;
    }
}
exports.List = List;
//# sourceMappingURL=list.js.map