"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
class Mean extends stream_1.PassThrough {
    constructor(handler) {
        super({ objectMode: true });
        this.accumulator = 0;
        this.counter = 0;
        this.handler = handler;
        this.on('data', (data) => {
            this.accumulator += this.handler(data);
            this.counter++;
        });
    }
    result() {
        return this.accumulator / this.counter;
    }
}
exports.Mean = Mean;
//# sourceMappingURL=mean.js.map