"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
class TransformObjectData extends stream_1.Transform {
    constructor(handler) {
        super({ objectMode: true });
        this.buffer = [];
        const defaultHandler = (obj) => undefined;
        this.handler = handler || defaultHandler;
    }
    _transform(data, encoding, callback) {
        try {
            const result = this.handler(data);
            typeof result !== 'undefined' ? callback(null, result) : callback();
        }
        catch (error) {
            callback(error, null);
        }
    }
}
exports.TransformObjectData = TransformObjectData;
//# sourceMappingURL=transform_object_data.js.map