"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _lib_1 = require("@lib");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
const unit_test_1 = require("../unit_test");
let UnitTestCollectJsonFile = class UnitTestCollectJsonFile extends unit_test_1.default {
    before() {
        this.mockFolder('./tmp');
    }
    after() {
        this.restoreFolder();
    }
    'can collect objects into file'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Collect.JsonFile('./tmp/demo.json'))
                .promise();
            result.should.be.an('object');
            result.should.have.keys('lines', 'bytes');
            result.lines.should.be.equal(3);
            const file = require('fs').readFileSync('./tmp/demo.json', 'utf-8');
            const writtenJson = JSON.parse(file);
            writtenJson.should.be.an('array');
            writtenJson.should.have.length(result.lines);
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTestCollectJsonFile.prototype, "can collect objects into file", null);
UnitTestCollectJsonFile = __decorate([
    mocha_typescript_1.suite('Collect::JSON-File')
], UnitTestCollectJsonFile);
//# sourceMappingURL=json_file.js.map