"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _lib_1 = require("@lib");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
let UnitTest = class UnitTest {
    'can passthrough (filter nothing)'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const transformer = obj => true;
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Filter(transformer))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.deep.equal({ a: 1 });
        });
    }
    'can block (filter all)'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const transformer = obj => false;
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Filter(transformer))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(0);
        });
    }
    'can filter by simple expression'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const transformer = obj => obj.a % 2 === 0;
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Filter(transformer))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(1);
            result[0].should.be.deep.equal({ a: 2 });
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can passthrough (filter nothing)", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can block (filter all)", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can filter by simple expression", null);
UnitTest = __decorate([
    mocha_typescript_1.suite('Transform::Filter')
], UnitTest);
//# sourceMappingURL=filter.js.map