"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _lib_1 = require("@lib");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
let UnitTest = class UnitTest {
    'can map objects in stream to other objects'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const mapper = obj => ({ b: obj.a + 1 });
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Map(mapper))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.deep.equal({ b: 2 });
        });
    }
    'can map objects in stream to strings'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const mapper = obj => JSON.stringify(obj);
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Map(mapper))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.deep.equal('{"a":1}');
        });
    }
    'can map objects in stream to static number'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const mapper = obj => 1;
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Map(mapper))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.equal(1);
        });
    }
    'can map objects in stream to empty string'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const mapper = obj => '';
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Map(mapper))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.equal('');
        });
    }
    'can map objects in stream to zero'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const map = obj => 0;
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Map(map))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.equal(0);
        });
    }
    'can map objects in stream to false'() {
        return __awaiter(this, void 0, void 0, function* () {
            const data = [{ a: 1 }, { a: 2 }, { a: 3 }];
            const mapper = obj => false;
            const result = yield new _lib_1.Origin.Array(data)
                .pipe(new _lib_1.Transform.Map(mapper))
                .pipe(new _lib_1.Collect.Array())
                .promise();
            result.should.be.an('array');
            result.should.have.length(3);
            result[0].should.be.equal(false);
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can map objects in stream to other objects", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can map objects in stream to strings", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can map objects in stream to static number", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can map objects in stream to empty string", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can map objects in stream to zero", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTest.prototype, "can map objects in stream to false", null);
UnitTest = __decorate([
    mocha_typescript_1.suite('Transform::Map')
], UnitTest);
//# sourceMappingURL=map.js.map