"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _lib_1 = require("@lib");
require("chai/register-should");
const mocha_typescript_1 = require("mocha-typescript");
const unit_test_1 = require("../unit_test");
let UnitTestParseLambdaLog = class UnitTestParseLambdaLog extends unit_test_1.default {
    before() {
        this.mockAwsCloudWatchLogs('lambda');
    }
    after() {
        this.restoreAwsCloudWatchLogs();
    }
    'can aggregate lambda events from cloudwatch log streams'() {
        return __awaiter(this, void 0, void 0, function* () {
            const name = '/aws/lambda/whatever';
            const yesterday = new Date().getTime() - 24 * 60 * 60 * 1000;
            const now = new Date().getTime();
            const data = yield new _lib_1.Origin.CloudWatchLog(name, yesterday, now)
                .pipe(new _lib_1.Transform.ParseLambdaLog())
                .pipe(new _lib_1.Collect.Array())
                .promise();
            data.should.be.an('array');
            data.should.have.length(3);
            data[0].should.have.keys('endTime', 'messages', 'performance', 'startTime');
            data[0].messages.should.be.an('array');
            data[0].messages.should.have.length(1);
        });
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], UnitTestParseLambdaLog.prototype, "can aggregate lambda events from cloudwatch log streams", null);
UnitTestParseLambdaLog = __decorate([
    mocha_typescript_1.suite('Transform::LambdaLog')
], UnitTestParseLambdaLog);
//# sourceMappingURL=parse_lambda_log.js.map