"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AWS = require("aws-sdk-mock");
const mockFS = require("mock-fs");
const cloudwatch_lambda_log_1 = require("../fixtures/cloudwatch_lambda_log");
const mockAwsCloudWatchLogs = (mode = 'default') => {
    const resp = mode === 'default'
        ? { events: [{ message: 'mocked' }] }
        : cloudwatch_lambda_log_1.default(3);
    const cb = (params, callback) => callback(null, resp);
    AWS.mock('CloudWatchLogs', 'filterLogEvents', cb);
};
const restoreAwsCloudWatchLogs = () => AWS.restore('CloudWatchLogs', 'filterLogEvents');
const mockFolder = path => mockFS({ [path]: {} });
const restoreFolder = () => mockFS.restore();
class UnitTest {
    constructor() {
        this.mockAwsCloudWatchLogs = mockAwsCloudWatchLogs;
        this.restoreAwsCloudWatchLogs = restoreAwsCloudWatchLogs;
        this.mockFolder = mockFolder;
        this.restoreFolder = restoreFolder;
    }
}
UnitTest.mockAwsCloudWatchLogs = mockAwsCloudWatchLogs;
UnitTest.restoreAwsCloudWatchLogs = restoreAwsCloudWatchLogs;
UnitTest.mockFolder = mockFolder;
UnitTest.restoreFolder = restoreFolder;
exports.default = UnitTest;
//# sourceMappingURL=unit_test.js.map